﻿namespace PopupMenuToolsProblem
{
    using System;
    using System.Collections.Generic;
    using System.Windows.Forms;

    using Infragistics.Win.UltraWinToolbars;
    using Infragistics.Win.UltraWinTree;

    /// <summary>
    /// The form 1.
    /// </summary>
    public partial class ApplicationForm : Form
    {
        /// <summary>
        /// The PopupMenuTool
        /// </summary>
        private PopupMenuTool popupMenuTool;

        /// <summary>
        /// The ButtonTool
        /// </summary>
        private ButtonTool buttonTool;

        /// <summary>
        /// Initializes a new instance of the <see cref="ApplicationForm"/> class.
        /// </summary>
        public ApplicationForm()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// The form 1 load.
        /// </summary>
        /// <param name="sender">
        /// The sender.
        /// </param>
        /// <param name="e">
        /// The e.
        /// </param>
        private void FormLoad(object sender, EventArgs e)
        {
            this.popupMenuTool = new PopupMenuTool("PopupMenuTool");
            this.popupMenuTool.SharedProps.Caption = "PopupMenuTool";

            var ribbonGroup = this.ultraToolbarsManager.Ribbon.Tabs[0].Groups[0];
            ribbonGroup.Tools.InsertToolForRibbonCustomization(0, this.popupMenuTool, false, new List<string>());

            var popupMenuNode = new UltraTreeNode("PopupMenuNode");
            this.ultraTree.Nodes.Insert(0, popupMenuNode);

            this.buttonTool = new ButtonTool("ButtonTool");
            this.buttonTool.SharedProps.Caption = "ButtonTool";

            this.popupMenuTool.Tools.InsertToolForRibbonCustomization(0, this.buttonTool, false, new List<string>());

            var buttonToolNode = new UltraTreeNode("ButtonToolNode");

            popupMenuNode.Nodes.Insert(0, buttonToolNode);
        }

        /// <summary>
        /// The ultra button 1_ click.
        /// </summary>
        /// <param name="sender">
        /// The sender.
        /// </param>
        /// <param name="e">
        /// The e.
        /// </param>
        private void UltraButtonClick(object sender, EventArgs e)
        {
            this.buttonTool.ParentCollection.Remove(this.buttonTool);

            /*popupMenuTool.Tools.Remove(buttonTool);*/ /* Same problem */
        }
    }
}
